c    "Copyright 2009 Prof. Robert Dalrymple, Prof. M. Gomez Gesteira, Dr Benedict Rogers, 
c     Dr Alejandro Crespo, Dr Muthukumar Narayanaswamy, Dr Shan Zou, Dr Andrea Panizzo "
c
c    This file is part of SPHYSICS.
c
c    SPHYSICS is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 3 of the License, or
c    (at your option) any later version.
c
c    SPHYSICS is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program.  If not, see <http://www.gnu.org/licenses/>.

      subroutine ac_main
c
      include 'common.3D'

c
c  ...  store useful arrays
c
      !- Need to zero each object for multiobjects -
      bigUdot   = 0.0
      bigVdot   = 0.0
      bigWdot   = 0.0        
      X_Friction   = 0.0
      Y_Friction   = 0.0
      Z_Friction   = 0.0        
      nb_inFriction = 0

      do i=nbfm+1,nb

c        -- Zeroing Variables for Free-Moving Objects --         

         ax(i) = 0.
         ay(i) = 0.
         az(i) = 0.
         ar(i) = 0.
         aVol(i) = 0.
         aTE(i) = 0.

      enddo

      do i=nstart,np
         
c        -- Zeroing Variables --         

         ax(i) = 0.
         ay(i) = 0.
         az(i) = 0.
         ar(i) = 0.
         aVol(i) = 0.
         aTE(i) = 0.

         ux(i) = 0.
         vx(i) = 0.
         wx(i) = 0.
         
         sum_wab(i) = 0.
         rhop_sum(i) = 0.

         dudx_CSPHo(i) = dudx_CSPH(i)
         dudy_CSPHo(i) = dudy_CSPH(i)
         dudz_CSPHo(i) = dudz_CSPH(i)
         dvdx_CSPHo(i) = dvdx_CSPH(i)
         dvdy_CSPHo(i) = dvdy_CSPH(i)
         dvdz_CSPHo(i) = dvdz_CSPH(i)
         dwdx_CSPHo(i) = dwdx_CSPH(i)
         dwdy_CSPHo(i) = dwdy_CSPH(i)
         dwdz_CSPHo(i) = dwdz_CSPH(i)
         dTEdx_CSPHo(i) = dTEdx_CSPH(i)
         dTEdy_CSPHo(i) = dTEdy_CSPH(i)
         dTEdz_CSPHo(i) = dTEdz_CSPH(i)
         drhodx_CSPHo(i) = drhodx_CSPH(i)
         drhody_CSPHo(i) = drhody_CSPH(i)
         drhodz_CSPHo(i) = drhodz_CSPH(i)
         
         drhoudx_CSPHo(i) = drhoudx_CSPH(i)
         drhoudy_CSPHo(i) = drhoudy_CSPH(i)
         drhoudz_CSPHo(i) = drhoudz_CSPH(i)
         drhovdx_CSPHo(i) = drhovdx_CSPH(i)
         drhovdy_CSPHo(i) = drhovdy_CSPH(i)
         drhovdz_CSPHo(i) = drhovdz_CSPH(i)
         drhowdx_CSPHo(i) = drhowdx_CSPH(i)
         drhowdy_CSPHo(i) = drhowdy_CSPH(i)
         drhowdz_CSPHo(i) = drhowdz_CSPH(i)
         dTotalEdx_CSPHo(i) = dTotalEdx_CSPH(i)
         dTotalEdy_CSPHo(i) = dTotalEdy_CSPH(i)
         dTotalEdz_CSPHo(i) = dTotalEdz_CSPH(i)
		
         dudx_CSPH(i) = 0.0
         dudy_CSPH(i) = 0.0
         dudz_CSPH(i) = 0.0
         dvdx_CSPH(i) = 0.0
         dvdy_CSPH(i) = 0.0
         dvdz_CSPH(i) = 0.0
         dwdx_CSPH(i) = 0.0
         dwdy_CSPH(i) = 0.0
         dwdz_CSPH(i) = 0.0
         drhodx_CSPH(i) = 0.0
         drhody_CSPH(i) = 0.0
         drhodz_CSPH(i) = 0.0

         drhoudx_CSPH(i) = 0.0
         drhoudy_CSPH(i) = 0.0
         drhoudz_CSPH(i) = 0.0
         drhovdx_CSPH(i) = 0.0
         drhovdy_CSPH(i) = 0.0
         drhovdz_CSPH(i) = 0.0
         drhowdx_CSPH(i) = 0.0
         drhowdy_CSPH(i) = 0.0
         drhowdz_CSPH(i) = 0.0
         dTotalEdx_CSPH(i) = 0.0
         dTotalEdy_CSPH(i) = 0.0
         dTotalEdz_CSPH(i) = 0.0

c       ---  Clear vorticity arrays ---
          if(ipoute.eq.1)then        
           curl3x_a(i)= 0.
           curl3x_b(i)= 0.
           curl3y_a(i)= 0.
           curl3y_b(i)= 0.
           curl3z_a(i)= 0.
           curl3z_b(i)= 0.
         end if

      enddo
      
      ly2=0  !initial zeroing of variable

       do kind_p1=1,2
       ini_kind_p2=mod(kind_p1,2)+1  !Gives the alternative value to kind_p2 of kind_p1
              
       do lz=1,ncz
       do ly=1,ncy
       do lx=1,ncx
         j1 = lx + (ly-1)*ncx +(lz-1)*nsheet

         if(nc(j1,kind_p1).gt.0) then
c                            ! if the cell is not empty, then
c                            ! loop over it and over neighboring
c                            ! cells

           lx2 = lx+1
           if(lx2.le.ncx)then
             call celij(j1,j1+1,kind_p1,ini_kind_p2,ly2)     !East
           endif
       
           ly2 = ly+1
           if(ly2.le.ncy)then
             call celij(j1,j1+ncx,kind_p1,ini_kind_p2,ly2)   !North
             lx2 = lx-1
             if(lx2.ge.1)call celij(j1,j1+ncall1,
     &                                 kind_p1,ini_kind_p2,ly2)   !N-West
       
             lx2 = lx+1
             if(lx2.le.ncx)call celij(j1,j1+ncall2,
     &                                 kind_p1,ini_kind_p2,ly2)   !N-East
           endif

c          -- Cells in the next XY  sheet --       
           lz2=lz+1
           if(lz2.le.ncz)then
       
             !- Same row -
             call celij(j1,j1+nsheet,kind_p1,ini_kind_p2,ly2) !Up
       
             lx2=lx-1
             if(lx2.ge.1) call celij(j1,j1+ncall3,
     &                                 kind_p1,ini_kind_p2,ly2)   !Up & West
       
             lx2=lx+1
             if(lx2.le.ncx) call celij(j1,j1+ncall4,
     &                                 kind_p1,ini_kind_p2,ly2)   !Up & East
       
             !- Next row -
             ly2=ly+1
             if(ly2.le.ncy) then
               call celij(j1,j1+ncall5,
     &                                 kind_p1,ini_kind_p2,ly2)   !Up & North
       
               lx2=lx-1
               if(lx2.ge.1) call celij(j1,j1+ncall6,
     &                                 kind_p1,ini_kind_p2,ly2)   !Up & North-West
       
               lx2=lx+1
               if(lx2.le.ncx) call celij(j1,j1+ncall7,
     &                                 kind_p1,ini_kind_p2,ly2)   !Up & North-East
             endif
       
             !- Previous row -
             ly2=ly-1
             if(ly2.ge.1) then
               call celij(j1,j1+ncall8,kind_p1,ini_kind_p2,ly2)    !Up & South
                                         
               lx2=lx-1
               if(lx2.ge.1) call celij(j1,j1+ncall9,
     &                                 kind_p1,ini_kind_p2,ly2)   !Up & SouthWest
       
               lx2=lx+1
               if(lx2.le.ncx) call celij(j1,j1+ncall10,
     &                                 kind_p1,ini_kind_p2,ly2)   !Up & SouthEast
             endif
       
           endif    !End of:   if(lz2.le.ncz)then
         endif    !End of:  if(nc(j1,kind_p1).gt.0) then
       
       enddo
       enddo
       enddo
       
       do j1=1,nct
           if(nc(j1,kind_p1).gt.0)
     +		call self(j1,kind_p1,ini_kind_p2)
       enddo
       
c      -- Periodic Boundary Calls in Y-Direction --              
       if(i_periodicOBs(2).eq.1)then
         ly = ncy
         ly2 = ly+1
         do lz = 2,ncz-1
          do lx = 2,ncx-1
           j1 = lx + (ly-1)*ncx +(lz-1)*nsheet
           call celij(j1,j1+ncall11,kind_p1,ini_kind_p2,ly2) !North Y-Periodic
           call celij(j1,j1+ncall12,kind_p1,ini_kind_p2,ly2) !North-West Y-Periodic
           call celij(j1,j1+ncall13,kind_p1,ini_kind_p2,ly2) !North-East Y-Periodic
           call celij(j1,j1+ncall14,kind_p1,ini_kind_p2,ly2) !Down & North Y-Periodic
           call celij(j1,j1+ncall15,kind_p1,ini_kind_p2,ly2) !Down & North-West Y-Periodic
           call celij(j1,j1+ncall16,kind_p1,ini_kind_p2,ly2) !Down & North-East Y-Periodic
           call celij(j1,j1+ncall17,kind_p1,ini_kind_p2,ly2) !Up & North Y-Periodic
           call celij(j1,j1+ncall18,kind_p1,ini_kind_p2,ly2) !Up & North-West Y-Periodic
           call celij(j1,j1+ncall19,kind_p1,ini_kind_p2,ly2) !Up & North-East Y-Periodic
          end do    !End of:  do lx = 2,ncx-1       
          !- Special Treatment for Corner Column Cells (lx=1 & lx=ncx) -
          !- Note this is for Y-Periodicity Only!               -
          !Norths & North-Easts of lx = 1 
          lx = 1
          j1 = lx + (ly-1)*ncx +(lz-1)*nsheet
          call celij(j1,j1+ncall11,kind_p1,ini_kind_p2,ly2) !North Y-Periodic
          call celij(j1,j1+ncall13,kind_p1,ini_kind_p2,ly2) !North-East Y-Periodic
          call celij(j1,j1+ncall14,kind_p1,ini_kind_p2,ly2) !Down & North Y-Periodic
          call celij(j1,j1+ncall16,kind_p1,ini_kind_p2,ly2) !Down & North-East Y-Periodic
          call celij(j1,j1+ncall17,kind_p1,ini_kind_p2,ly2) !Up & North Y-Periodic
          call celij(j1,j1+ncall19,kind_p1,ini_kind_p2,ly2) !Up & North-East Y-Periodic
          !Norths & North-Wests of lx = ncx 
          lx = ncx
          j1 = lx + (ly-1)*ncx +(lz-1)*nsheet
          call celij(j1,j1+ncall11,kind_p1,ini_kind_p2,ly2) !North Y-Periodic
          call celij(j1,j1+ncall12,kind_p1,ini_kind_p2,ly2) !North-West Y-Periodic
          call celij(j1,j1+ncall14,kind_p1,ini_kind_p2,ly2) !Down & North Y-Periodic
          call celij(j1,j1+ncall15,kind_p1,ini_kind_p2,ly2) !Down & North-West Y-Periodic
          call celij(j1,j1+ncall17,kind_p1,ini_kind_p2,ly2) !Up & North Y-Periodic
          call celij(j1,j1+ncall18,kind_p1,ini_kind_p2,ly2) !Up & North-West Y-Periodic
         end do  !End of:  do lz = 2,ncz-1
         !- Special Treatment for Bottom & Top Sheets (lz=1 & lz=ncz) -
         !- Note this is for Y-Periodicity Only!               -
         ly = ncy
         ly2 = ly+1
         do lx = 2,ncx-1
          !Norths of lz = 1 
          lz = 1
          j1 = lx + (ly-1)*ncx +(lz-1)*nsheet
          call celij(j1,j1+ncall11,kind_p1,ini_kind_p2,ly2) !North Y-Periodic
          call celij(j1,j1+ncall12,kind_p1,ini_kind_p2,ly2) !North-West Y-Periodic
          call celij(j1,j1+ncall13,kind_p1,ini_kind_p2,ly2) !North-East Y-Periodic
          call celij(j1,j1+ncall17,kind_p1,ini_kind_p2,ly2) !Up & North Y-Periodic
          call celij(j1,j1+ncall18,kind_p1,ini_kind_p2,ly2) !Up & North-West Y-Periodic
          call celij(j1,j1+ncall19,kind_p1,ini_kind_p2,ly2) !Up & North-East Y-Periodic
          !Norths of lz = ncz 
          lz = ncz
          j1 = lx + (ly-1)*ncx +(lz-1)*nsheet
          call celij(j1,j1+ncall11,kind_p1,ini_kind_p2,ly2) !North Y-Periodic
          call celij(j1,j1+ncall12,kind_p1,ini_kind_p2,ly2) !North-West Y-Periodic
          call celij(j1,j1+ncall13,kind_p1,ini_kind_p2,ly2) !North-East Y-Periodic
          call celij(j1,j1+ncall14,kind_p1,ini_kind_p2,ly2) !Down & North Y-Periodic
          call celij(j1,j1+ncall15,kind_p1,ini_kind_p2,ly2) !Down & North-West Y-Periodic
          call celij(j1,j1+ncall16,kind_p1,ini_kind_p2,ly2) !Down & North-East Y-Periodic
         enddo
         !- Special Treatment for Bottom & Top Corners 
         !- (lx,ly,lz=(1,ncy,1),(ncx,ncy,1),(ncx,ncy,ncz),(1,ncy,ncz) -
         !- Note this is for Y-Periodicity Only!                      -
         !- (1,ncy,1)     -
         lx = 1
         ly = ncy
         lz = 1
         ly2 = ly + 1
         j1 = lx + (ly-1)*ncx +(lz-1)*nsheet
         call celij(j1,j1+ncall11,kind_p1,ini_kind_p2,ly2) !North Y-Periodic
         call celij(j1,j1+ncall13,kind_p1,ini_kind_p2,ly2) !North-East Y-Periodic
         call celij(j1,j1+ncall17,kind_p1,ini_kind_p2,ly2) !Up & North Y-Periodic
         call celij(j1,j1+ncall19,kind_p1,ini_kind_p2,ly2) !Up & North-East Y-Periodic
         !- (ncx,ncy,1)   -
         lx = ncx
         ly = ncy
         lz = 1
         ly2 = ly + 1
         j1 = lx + (ly-1)*ncx +(lz-1)*nsheet
         call celij(j1,j1+ncall11,kind_p1,ini_kind_p2,ly2) !North Y-Periodic
         call celij(j1,j1+ncall12,kind_p1,ini_kind_p2,ly2) !North-West Y-Periodic
         call celij(j1,j1+ncall17,kind_p1,ini_kind_p2,ly2) !Up & North Y-Periodic
         call celij(j1,j1+ncall18,kind_p1,ini_kind_p2,ly2) !Up & North-West Y-Periodic
         !- (ncx,ncy,ncz) -
         lx = ncx
         ly = ncy
         lz = ncz
         ly2 = ly + 1
         j1 = lx + (ly-1)*ncx +(lz-1)*nsheet
         call celij(j1,j1+ncall11,kind_p1,ini_kind_p2,ly2) !North Y-Periodic
         call celij(j1,j1+ncall12,kind_p1,ini_kind_p2,ly2) !North-West Y-Periodic
         call celij(j1,j1+ncall14,kind_p1,ini_kind_p2,ly2) !Down & North Y-Periodic
         call celij(j1,j1+ncall15,kind_p1,ini_kind_p2,ly2) !Down & North-West Y-Periodic
         !- (1,ncy,ncz)   -
         lx = 1
         ly = ncy
         lz = ncz
         ly2 = ly + 1
         j1 = lx + (ly-1)*ncx +(lz-1)*nsheet
         call celij(j1,j1+ncall11,kind_p1,ini_kind_p2,ly2) !North Y-Periodic
         call celij(j1,j1+ncall13,kind_p1,ini_kind_p2,ly2) !North-East Y-Periodic
         call celij(j1,j1+ncall14,kind_p1,ini_kind_p2,ly2) !Down & North Y-Periodic
         call celij(j1,j1+ncall16,kind_p1,ini_kind_p2,ly2) !Down & North-East Y-Periodic
       endif   !End of:  if(i_periodicOBs(2).eq.1)then
       !-----  End of Y-Periodicity --------------------------   
       
       enddo   !End of:  do kind_p1=1,2
       
       
       
       do i=nstart,np
         
c         udot(i) = ax(i)
c         vdot(i) = ay(i)
c         wdot(i) = az(i)
c         rdot(i) = ar(i)
       
         if(sum_wab(i).lt.0.1) then
            one_over_sum_wab=1.
         else
           one_over_sum_wab=1./sum_wab(i)
         endif
       
         xcor(i) = eps*ux(i)   !*one_over_sum_wab	! NORMALIZING KERNELS
         ycor(i) = eps*vx(i)   !*one_over_sum_wab
         zcor(i) = eps*wx(i)   !*one_over_sum_wab
       
c         TEdot(i)=aTE(i)
       
       enddo
              
       return
       end
